<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="科目编号" prop="finItemCode">
              <el-select v-model="queryParams.finItemCode" placeholder="请选择科目编号" clearable>
                <template #header>
                  <el-input v-model="likeName" placeholder="可根据科目编码或科目名称模糊查询" clearable @input="filterByItemCode"></el-input>
                </template>
                <el-option
                  v-for="dict in filteredFinitem"
                  :key="dict.finItemCode"
                  :label="dict.finItemCode + '-' + dict.finItemName"
                  :value="dict.finItemCode"
                ></el-option>
              </el-select>
            </el-form-item>
            <!--            <el-form-item label="科目名称" prop="finItemName">-->
            <!--              <el-input v-model="queryParams.finItemName" placeholder="请输入科目名称" clearable @keyup.enter="handleQuery" />-->
            <!--            </el-form-item>-->
            <!--            <el-form-item label="科目描述" prop="remark">-->
            <!--              <el-input v-model="queryParams.remark" placeholder="请输入科目描述" clearable @keyup.enter="handleQuery" />-->
            <!--            </el-form-item>-->
            <el-row>
              <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
              </el-form-item>
            </el-row>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button v-hasPermi="['bfs:finItemDef:add']" type="primary" plain icon="Plus" @click="handleAdd">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-hasPermi="['bfs:finItemDef:export']" type="warning" plain icon="Download" @click="handleExport">导出</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-hasPermi="['bfs:finItemDef:import']" type="danger" plain icon="Upload" @click="handleImport">导入</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @query-table="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="finItemDefList">
        <el-table-column label="科目类型" align="center" prop="finItemType">
          <template #default="scope">
            <dict-tag :options="bfs_finiterm_type" :value="scope.row.finItemType" />
          </template>
        </el-table-column>
        <el-table-column label="科目编号" align="center" prop="finItemCode" />
        <el-table-column label="科目名称" align="center" prop="finItemName" width="200px" show-overflow-tooltip />
        <el-table-column label="明细科目编码" align="center" prop="subItemCode" />
        <el-table-column label="明细科目名称" align="center" prop="subItemName" width="200px" show-overflow-tooltip />
        <el-table-column label="item表的主键ID" align="center" prop="itemId" v-if="false" />
        <el-table-column label="sub表的主键ID" align="center" prop="subId" v-if="false" />
        <el-table-column label="状态" align="center" prop="status" width="200px" show-overflow-tooltip>
          <template #default="scope">
            <dict-tag :options="sys_yesno_valid" :value="scope.row.status" />
          </template>
<!--          <template #default="scope">-->
<!--            <el-switch-->
<!--              v-model="scope.row.status"-->
<!--              active-value="Y"-->
<!--              inactive-value="N"-->
<!--              inline-prompt-->
<!--              active-text="有效"-->
<!--              inactive-text="无效"-->
<!--              @change="handleStatusChange(scope.row)"-->
<!--            ></el-switch>-->
<!--          </template>-->
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button v-hasPermi="['bfs:finItemDef:edit']" link type="primary" icon="Edit" @click="handleUpdate(scope.row)"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" :total="total" @pagination="getList" />
    </el-card>
    <!-- 添加或修改科目信息对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="500px" append-to-body>
      <el-form ref="finItemDefFormRef" :model="form" :rules="rules" label-width="90px">
        <el-form-item label="科目类型" prop="finItemType">
          <el-select v-model="form.finItemType" placeholder="请选择科目类型">
            <el-option v-for="dict in bfs_finiterm_type" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="科目编号" prop="finItemCode">
          <el-input v-model="form.finItemCode" placeholder="请输入科目编号" />
        </el-form-item>
        <el-form-item label="科目名称" prop="finItemName">
          <el-input v-model="form.finItemName" placeholder="请输入科目名称" />
        </el-form-item>
        <el-form-item label="明细科目编号" prop="subItemCode">
          <el-input v-model="form.subItemCode" placeholder="请输入明细科目编码" />
        </el-form-item>
        <el-form-item label="明细科目名称" prop="subItemName">
          <el-input v-model="form.subItemName" placeholder="请输入明细科目名称" />
        </el-form-item>
<!--        <el-form-item label="描述" prop="remark">-->
<!--          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />-->
<!--        </el-form-item>-->
        <el-form-item label="状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择科目类型">
            <el-option v-for="dict in sys_yesno_valid" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>

    <el-dialog v-model="upload.open" :title="upload.title" width="400px" append-to-body>
      <el-upload
        ref="uploadRef"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <el-icon class="el-icon--upload">
          <i-ep-upload-filled />
        </el-icon>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <template #tip>
          <div class="text-center el-upload__tip">
            <span>仅允许导入xls、xlsx格式文件。</span>
            <el-link type="primary" :underline="false" style="font-size: 12px; vertical-align: baseline" @click="importTemplate">下载模板</el-link>
          </div>
        </template>
      </el-upload>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitFileForm">确 定</el-button>
          <el-button @click="upload.open = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="FinItemDef" lang="ts">
import {
  listFinItemDef,
  getFinItemDef,
  delFinItemDef,
  addFinItemDef,
  updateFinItemDef,
  getSubList,
  deleteSub,
  addSub,
  getFinItemList,
  changeStatus,
  checkOnlyOne
} from '@/api/bfs/finItemDef/index';
import { FinItemDefVO, FinItemDefQuery, FinItemDefForm } from '@/api/bfs/finItemDef/types';
import {globalHeaders, globalUploadHeaders} from '@/utils/request';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const finItemDefList = ref<FinItemDefVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const selectRow = ref([]);
const likeName = ref('');
const filteredFinitem = ref([]);
const finItemList = ref([]);

const { bfs_finiterm_type, bfs_finiterm_state, sys_yesno_valid } = toRefs<any>(proxy?.useDict('bfs_finiterm_type', 'bfs_finiterm_state', 'sys_yesno_valid'));

const queryFormRef = ref<ElFormInstance>();
const finItemDefFormRef = ref<ElFormInstance>();
const checkRow = ref([]);
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const subItemDialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const subItemLoading = ref(false);
const finItemSubList = ref([]);
const isLookSub = ref(false);

/*** 用户导入参数 */
const upload = reactive<ImportOption>({
  // 是否显示弹出层（用户导入）
  open: false,
  // 弹出层标题（用户导入）
  title: '',
  // 是否禁用上传
  isUploading: false,
  // 是否更新已经存在的用户数据
  updateSupport: 0,
  // 设置上传的请求头部
  headers: globalUploadHeaders(),
  // 上传的地址
  url: import.meta.env.VITE_APP_BASE_API + '/bfs/finItemDef/importData'
});

const initFormData: FinItemDefForm = {
  id: undefined,
  versionNo: '0001',
  finItemCode: undefined,
  finItemName: undefined,
  finItemType: undefined,
  subItemCode: undefined,
  subItemName: undefined,
  dealMode: '1',
  dealSpecialClass: undefined,
  remark: undefined,
  status: 'Y',
  itemId: undefined,
  subId: undefined
};
const data = reactive({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    finItemCode: undefined,
    finItemName: undefined,
    finItemType: undefined,
    dealMode: undefined,
    dealSpecialClass: undefined,
    status: undefined,
    remark: undefined,
    params: {}
  },
  rules: {
    finItemCode: [{ required: true, message: '科目编号不能为空', trigger: 'blur' }],
    finItemName: [{ required: true, message: '科目名称不能为空', trigger: 'blur' }],
    finItemType: [{ required: true, message: '科目类型不能为空', trigger: 'change' }],
    status: [{ required: true, message: '状态不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);
const uploadRef = ref<ElUploadInstance>();

/** 查询科目信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await listFinItemDef(queryParams.value);
  finItemDefList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  checkRow.value = [];
  form.value = { ...initFormData };
  finItemDefFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加科目信息';
};

/** 修改按钮操作 */
const handleUpdate = async (row) => {
  reset();
  checkRow.value = row;
  Object.assign(form.value, row);
  dialog.visible = true;
  dialog.title = '修改科目信息';
};

/** 提交按钮 */
const submitForm = () => {
  finItemDefFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      // buttonLoading.value = true;
      if (form.value.itemId) {
        if (checkRow.value.finItemCode !== form.value.finItemCode || checkRow.value.finItemName !== form.value.finItemName) {
          await proxy?.$modal.confirm('修改了科目代码或科目名称，将会修改所有明细科目的科目代码和科目名称，是否继续？');
        }
        if(checkRow.value.subItemCode === null && form.value.subItemCode !== null){
          proxy?.$modal.msgError('原科目不存在明细科目，请通过新增方式新增明细科目');
          return;
        }
        await updateFinItemDef(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await proxy?.$modal.confirm('如果科目编码存在既往数据，会将对应科目下的所有明细科目的科目名称更新成最新，是否继续？');
        await addFinItemDef(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: FinItemDefVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal
    .confirm('是否确认删除科目信息编号为"' + row.finItemCode + '-' + row.finItemName + '"的数据项？')
    .finally(() => (loading.value = false));
  await delFinItemDef(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'bfs/finItemDef/export',
    {
      ...queryParams.value
    },
    `科目明细_${new Date().getTime()}.xlsx`
  );
};

/** 导入按钮操作 */
const handleImport = () => {
  upload.title = '导入';
  upload.open = true;
};

/** 下载模板操作 */
const importTemplate = () => {
  proxy?.download('bfs/finItemDef/importTemplate', {}, `科目明细导入模版_${new Date().getTime()}.xlsx`);
};

/** 提交上传文件 */
function submitFileForm() {
  uploadRef.value?.submit();
}

/**文件上传中处理 */
const handleFileUploadProgress = () => {
  upload.isUploading = true;
};
/** 文件上传成功处理 */
const handleFileSuccess = (response: any, file: UploadFile) => {
  upload.open = false;
  upload.isUploading = false;
  uploadRef.value?.handleRemove(file);
  ElMessageBox.alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + '</div>', '导入结果', {
    dangerouslyUseHTMLString: true
  });
  getList();
};

/**
 * 查看明细科目
 */
const handleLookSub = async (row) => {
  const res = await getSubList(row.finItemCode);
  finItemSubList.value = res.data;
  subItemDialog.visible = true;
  subItemDialog.title = '明细科目查询';
  subItemLoading.value = false;
  isLookSub.value = true;
};

/**
 * 编辑明细科目
 */
const handleEditSub = async (row) => {
  selectRow.value = row;
  const res = await getSubList(row.finItemCode);
  finItemSubList.value = res.data;
  subItemDialog.visible = true;
  subItemDialog.title = '编辑明细科目';
  subItemLoading.value = false;
  isLookSub.value = false;
};

/**
 * 明细科目行增加
 */
const addRow = () => {
  const newRow = {
    finItemCode: selectRow.value.finItemCode,
    finItemName: selectRow.value.finItemName,
    finItemType: selectRow.value.finItemType,
    subItemCode: undefined,
    subItemName: undefined
  };
  finItemSubList.value.push(newRow);
};
/**
 * 明细科目删除
 */
const handleSubDelete = async (row) => {
  if (!row.id) {
    //如果不是查询来的数据，即不存在row.id，则直接从列表中移除选择行
    finItemSubList.value = finItemSubList.value.filter((item) => item !== row);
  } else {
    const res = await deleteSub(row);
    if (res.code == 200 && res.data == true) {
      finItemSubList.value = finItemSubList.value.filter((item) => item !== row);
    }
  }
};

/**
 * 明细科目保存
 */
const handleAddSubValues = async () => {
  const res = await addSub(finItemSubList.value);
  if (res.code == 200 && res.data == true) {
    proxy?.$modal.msgSuccess('操作成功');
    subItemDialog.visible = false;
    selectRow.value = [];
    finItemSubList.value = [];
    getList();
  }
};

/**
 * 初始化下拉列表
 */
const initFinItem = async () => {
  const res = await getFinItemList();
  if (res.code == 200) {
    filteredFinitem.value = res.data;
    finItemList.value = res.data;
  }
};

const filterByItemCode = () => {
  if (likeName.value) {
    filteredFinitem.value = finItemList.value.filter((item) => {
      return item.finItemCode.includes(likeName.value) || item.finItemName.includes(likeName.value);
    });
  } else {
    filteredFinitem.value = finItemList.value;
  }
};

/** 状态修改  */
const handleStatusChange = async (row) => {
  let text = row.status === 'Y' ? '启用' : '停用';
  try {
    await proxy?.$modal.confirm('确认要"' + text + '"吗?');
    let isOnlyOne = await checkOnlyOne(row);
    isOnlyOne = isOnlyOne.data;
    if (isOnlyOne && row.status === 'N') {
      let isUpdateItem = false;
      try {
        await ElMessageBox.confirm('科目编码"' + row.finItemCode + '"仅包含当前明细科目，是否一并停用科目"' + row.finItemCode + '"?', '系统提示', {
          confirmButtonText: '一并停用科目编码',
          cancelButtonText: '仅停用明细科目',
          type: 'warning'
        });
        isUpdateItem = true;
      } catch (error) {
        isUpdateItem = false;
      }
      await changeStatus(row, isUpdateItem);
    } else {
      await changeStatus(row, false);
    }
    proxy?.$modal.msgSuccess(text + '成功');
  } catch (err) {
    row.status = row.status === 'N' ? 'Y' : 'N';
  }
  getList();
};

onMounted(() => {
  getList();
  initFinItem();
});
</script>
